/* $Id: toy.h,v 1.7 2009/02/19 14:42:10 mit-sato Exp $ */

#ifndef __TOY__
#define __TOY__

#include <t_gc.h>
#include "types.h"
#include "cell.h"
#include "hash.h"
#include "bulk.h"
#include "parser.h"
#include "interp.h"
#include "error.h"

Toy_Type *toy_eval_script(Toy_Interp* interp, Toy_Type *script);
Toy_Type *toy_eval(Toy_Interp* interp, Toy_Type *statement, Toy_Env** env);
Toy_Type *toy_expand(Toy_Interp* interp, Toy_Type* obj, Toy_Env** env);
Toy_Type *toy_expand_list(Toy_Interp* interp, Toy_Type* list, Toy_Env** env);
Toy_Type *toy_resolv_var(Toy_Interp* interp, Toy_Type* var, int stack_trace);
Toy_Type *toy_resolv_function(Toy_Interp* interp, Toy_Type* obj);
Toy_Type *toy_resolv_object(Toy_Interp* interp, Toy_Type* obj);
Toy_Type *toy_apply_func(Toy_Interp* interp, Toy_Type* func, Toy_Type* posargs, Hash* nameargs, int arglen);
Toy_Type *toy_call_function(Toy_Interp* interp, Toy_Type *script,
		  Toy_Type *posargs, Hash *nameargs, Toy_Type *argspec_list, int arglen);
Toy_Type *toy_resolv_object(Toy_Interp *interp, Toy_Type *object);
Toy_Type *eval_closure(Toy_Interp *interp, Toy_Type *closure);
Toy_Type *toy_call_init(Toy_Interp *interp, Toy_Type *object, Toy_Type *args);
Toy_Type *toy_call(Toy_Interp *interp, Toy_Type *list);
char	 *to_string_call(Toy_Interp *interp, Toy_Type *obj);


#ifdef __FreeBSD__
#	define SETJMP(x)	_setjmp(x)
#	define LONGJMP(x,y)	_longjmp(x,y)
#else
#	define SETJMP(x)	setjmp(x)
#	define LONGJMP(x,y)	longjmp(x,y)
#endif /* __FreeBSD__ */

#define CTRL_RETURN		1
#define CTRL_BREAK		2
#define CTRL_CONTINUE		3
#define CTRL_REDO		4
#define CTRL_RETRY		5

#endif /* __TOY__ */
